/*
	CGI Source for TextCorrect.cpp

	Author	: Kang Jul Ki (Master 2nd)
	E-mail	: jkkang@sel.chonbuk.ac.kr
	Homepage: http://sel.chonbuk.ac.kr/~jkkang/
	Date	: January 29, 1997
	Class	: Software Engineering Lab.
		  Dept. of Electronic Engineering
		  Chonbuk National Univ.	

	Compiler: Visual C++ 4.2
	Copyright (c) 1997, Kang Jul Ki & Software Engineering Lab
*/

#include "TextCorrect.h"
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

TextCorrect::TextCorrect()
{
}

TextCorrect::~TextCorrect()
{
}

void TextCorrect::GetEnv()
{
	int	cl = 0, i;

	/*
	** Get BoardNum and TextNum from 'QUERY_STRING'
	*/
	cl  = atoi(getenv("CONTENT_LENGTH"));
	buf = getenv("QUERY_STRING");

	for (i=0; i<2; i++)
	{
		(iParam+i)->f_val  = (char *)makeword(buf, '&');
		(iParam+i)->f_name = (char *)makeword((iParam+i)->f_val, '=');
#ifdef _DEBUG_
	printf("%s%c", (iParam+i)->f_name, LF);
	printf("%s%c%s", (iParam+i)->f_val, LF, "<br>");
#endif
	}

	/*
	** Set iBoardNum and iTextNum
	*/
	iBoardNum = atoi((iParam+0)->f_val);
	iTextNum  = atoi((iParam+1)->f_val);

#ifdef _DEBUG_
	printf("iBoardNum = %d%c", GetBoardNum(), LF);
	printf("iTextNum  = %d%c", GetTextNum(), LF);
#endif

	/*
	** Get content
	*/
	for (i=0; cl && (!feof(stdin)); i++)
	{
		(iParam+i)->f_val	= fmakeword(stdin, '&', &cl);
		plustospace((iParam+i)->f_val);
		unescape_url((iParam+i)->f_val);
		(iParam+i)->f_name	= makeword((iParam+i)->f_val, '=');
#ifdef _DEBUG_
	printf("cl = %d, %s : %s%c<br>", cl, (iParam+i)->f_name, (iParam+i)->f_val, LF);
#endif
	}

	/*
	** Get password from HTTP
	*/
	strcpy(passwd, (iParam+0)->f_val);

	/*
	** Get Config from 'GuestBook.conf'
	*/
	ProcessConfig();
}

stat TextCorrect::IsCanCorrect()
{
	if (strcmp(passwd, GetPassword()))
	{
		return	ERR;
	}

	return	OK;
}

stat TextCorrect::GetOpenDataFile()
{
	/*
	** fopen()
	**	'r' or 'rb':	open for reading
	**	'w' or 'wb':	truncate to zero length or create for writing
	**	'r+'or 'r+b':	open for update (reading and writing)
	**	'w+'or 'w+b':	truncate or create for update
	*/
	sprintf(fname, "%s%s", GetBbsDir(), "guestbook.dat");

	fpt = fopen(fname, "r");

	if (fpt == NULL)
	{
		printf("Can't open %s!!!%c", fname, LF);
		return	ERR;
	}

	return	OK;
}

void TextCorrect::SetRecord()
{
	long	lSkip;

	lSkip = HEADER_SIZE + RECORD_SIZE * (GetTextNum() - 1);

	/*
	** Jump to the location and save current file pointer
	*/
	fseek(fpt, lSkip, SEEK_SET);

	fread(rcd, RECORD_SIZE, 1, fpt);

	fclose(fpt);
}

void TextCorrect::GetOpenHtmlFile()
{
	/*
	** Get html file from iBoardNum and iTextNum
	*/
	sprintf(fname, "%s%s", GetBbsDir(), rcd->szHtmlName);

#ifdef _DEBUG_
	printf("fname = %s%c", fname, LF);
#endif

	fpt = fopen (fname, "r");

	if (fpt == NULL)
	{
		printf("Can't open %s!!!%c", fname, LF);
		exit(1);
	}
}

void TextCorrect::ShowHtmlFile()
{
	int	ch;
	fpos_t	pos;
	char	szTmp[10] = "";

	printf("<html>%c", LF);
	printf("<head><title>Խ  2.11</title></head>%c", LF);
	printf("<body bgcolor=white>%c", LF);

	printf("<center>%c", LF);
	printf("<img src=%sImage/%s height=60 width=200 border=0>%c", GetBaseDir(), GetImageFileName(), LF);
	printf("<table border=0 width=480 cellpading=0>%c", LF);
	  printf("<tr>%c", LF);
	    printf("<td valign=buttom>%c", LF);
	    printf("<img align=left border=0 src=%sImage/bookpen.gif>%c", GetBaseDir(), LF);
	      printf("<br>%c", LF);
	    printf("<img width=420 src=%sImage/line_ani.gif>%c", GetBaseDir(), LF); 
	    printf("</td>%c", LF);
	  printf("</tr>%c", LF);
	printf("</table>%c", LF);
	printf("</center>%c", LF);

	printf("<center>%c", LF);
	printf("<form method=post action=%scgi-bin/TextPost.exe?BoardNum=%d&TextNum=%d>%c", GetBaseDir(), GetBoardNum(), GetTextNum(), LF);
	printf("<table>%c", LF);

	printf("<tr><td>Name</td><td><input type=text name=name size=20 maxlength=18 value=\"%s\"></td></tr>%c", rcd->szName, LF);
	printf("<tr><td>E-mail</td><td><input type=text name=email size=40 maxlength=40 value=\"%s\"></td></tr>%c", rcd->szEmail, LF);
	printf("<tr><td>Homepage</td><td><input type=text name=homepage size=60 value=\"%s\"%c", rcd->szHomePage, LF);
	printf("maxlength=60></td><tr>%c", LF);
	printf("<tr><td>Subject</td><td><input type=text name=subject size=60 value=\"%s\" maxlength=60></td></tr>%c", rcd->szTitle, LF);
	printf("<tr><td>Comment</td><td><textarea type=text name=body cols=60 rows=10>%c", LF);
	
	while ((ch = getc(fpt)) != EOF)
	{
		if (ch == '<')
		{
			fgetpos(fpt, &pos);
			szTmp[0] = '<';
			for (int i=1; i<=3; i++)
				szTmp[i] = getc(fpt);
			szTmp[i] = '\0';
			
			if (!strcmp(szTmp, "<br>"))
			{
				;
			}
			else
			{
				fsetpos(fpt, &pos);
				putchar(ch);
			}
		}
		else	putchar(ch);
	}

	fclose(fpt);

	printf("</textarea>%c", LF);
	printf("</td></tr></table>%c", LF);

//	printf("<input type=hidden name=cur value=proposal>%c", LF);
	printf("<br>%c", LF);
 
	printf("<center>%c", LF);
		printf("<input type=submit value=\" ø\">%c", LF);
		printf("<input type=reset value=\"ϱ\">%c", LF);
	printf("</center>%c", LF);

	printf("</form>%c", LF);
	printf("<br>%c", LF);
	printf("</center>%c", LF);

	printf("<p>%c", LF);

	printf("<center>%c", LF);
	printf("<img src=%sImage/line.gif>%c", GetBaseDir(), LF);
	printf("<br>%c", LF);

	printf("<font color=454545 size=-1>Copyright <font size=4>&copy</font> 1996 - 1997,%c", LF);
	printf("Ver 2.11 Software Engineering Lab. All rights reserved.</br>%c", LF);
	printf("Chonbuk National Univ. Dept. of Electronic Engineering<br>%c", LF);
	printf("<a href=http://sel.chonbuk.ac.kr/~jkkang/>Programmed by Kang Jul Ki</a><br>%c", LF);
	printf("<a href=mailto:%s>%s</a></br>%c", GetEmail(), GetEmail(), LF);
	printf("</font>%c", LF);
	printf("</center>%c", LF);

	printf("</body>%c", LF);
	printf("</html>%c", LF);
}

/*
** Program Entry
*/
void main()
{
	TextCorrect* MyTextCorrect;
	stat	     result;

	MyTextCorrect = new TextCorrect;

	/*
	** Mime type
	*/
	printf("Content-type: text/html%c%c", LF, LF);

	MyTextCorrect->GetEnv();

	result = MyTextCorrect->IsCanCorrect();

	if (result == ERR)
	{
		char	str[MAX_STRING_LEN];

		sprintf(str, "<font color=228b22 size=2>Access denied.</font><br>%c\
			      <font color=454545 size=-1>մ ϱ  ϴ.</font><br>", LF);

		MyTextCorrect->ShowError(str);
		delete	MyTextCorrect;

		exit(0);
	}		

	MyTextCorrect->GetOpenDataFile();
	MyTextCorrect->SetRecord();
	MyTextCorrect->GetOpenHtmlFile();
	MyTextCorrect->ShowHtmlFile();

	delete	MyTextCorrect;
}
